// Demo_MSVS2008.cpp : Defines the entry point for the console application.
//
#define _CRT_SECURE_NO_WARNINGS

#include "stdafx.h"
#include <windows.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <stdio.h>

//---------------------------------------------------------------------------

#include "PDF417Pro_Types.h"
#include "LoadBMP.cpp"

const int   // the images size
  maxR = 3000
 ,maxC = 3000;
static unsigned char  pmembits[maxR*maxC];

int _tmain(int argc, _TCHAR* argv[])
{
   char ch;
   int    rowcount;
   int    colcount;
   TRow pbits[maxR];
 
   PPDF417_Decoder     pdecoder;
   PPDF417_Options     pdec_with_options[2];
   TPDF417_OptMode     optmode;
   TPDF417_ImageInfo*  pimageinfo;
   TPDF417_Info*       pinfo;

   HINSTANCE      DLLInstance;

   TConnect_PDF_Decoder      Connect_PDF_Decoder    ;
   TDisconnect_PDF_Decoder   Disconnect_PDF_Decoder ;

   TCreate_PDF_Options       Create_PDF_Options     ;
   TDelete_PDF_Options       Delete_PDF_Options     ;

   TDecodePDF_Bits           DecodePDF_Bits         ;
   TGetPDF_ImageInfo         GetPDF_ImageInfo       ;
   TGetPDF_Info              GetPDF_Info            ;

   const char* files[]=
   { 
      "Samples\\im1.bmp",
      "Samples\\im2.bmp",
      NULL   // last member of array must be NULL 
   };
   int 	  ResLoadBMP;
   int row, i, k;
   int DecodedSymbolNo;
   int iBWF;
 
#ifdef _WIN64
   const wchar_t LibName[] = L"PDF_PRO64.dll";
#else
   const wchar_t LibName[] = L"PDF_PRO32.dll";
#endif
   DLLInstance = ::LoadLibrary(LibName);

   if (DLLInstance != 0) 
   {
      Connect_PDF_Decoder      = (TConnect_PDF_Decoder      )::GetProcAddress(DLLInstance,"Connect_PDF417_Decoder");
      Disconnect_PDF_Decoder   = (TDisconnect_PDF_Decoder   )::GetProcAddress(DLLInstance,"Disconnect_PDF417_Decoder");
      Create_PDF_Options       = (TCreate_PDF_Options       )::GetProcAddress(DLLInstance,"Create_PDF417_Options");
      Delete_PDF_Options       = (TDelete_PDF_Options       )::GetProcAddress(DLLInstance,"Delete_PDF417_Options");
      DecodePDF_Bits           = (TDecodePDF_Bits           )::GetProcAddress(DLLInstance,"Decode_PDF417_Bits");
      GetPDF_ImageInfo         = (TGetPDF_ImageInfo         )::GetProcAddress(DLLInstance,"GetPDF417_ImageInfo");
      GetPDF_Info              = (TGetPDF_Info              )::GetProcAddress(DLLInstance,"GetPDF417_Info");
   }
   else
   {
    printf("DLL not found!\n");
    goto DoExit; // dll not found
   }
   if (Connect_PDF_Decoder != NULL) 
   {
    for (row = 0; row < maxR; row++)
    {
      pbits[row] = &(pmembits[maxC*row]);
    }
    // ==== construct decoder:
    pdecoder = Connect_PDF_Decoder(maxR,maxC);
    if(pdecoder == NULL) 
       return NULL;

    optmode.MaxSymbolCount   = 1;
    optmode.SpeedMode    = SP_Fast; // SP_Robust;
    optmode.CalcGrade    = false;
    optmode.DirectMode   = DM_LeftRight;
    optmode.BWFilter     = 0; // -1
    optmode.TimeOut      = 0; 
    optmode.ScanStep     = 4;

    // ==== construct the options:
    pdec_with_options[0]  = Create_PDF_Options(pdecoder, optmode);
    optmode.BWFilter      = -1; // bar wudth reduction
	pdec_with_options[1]  = Create_PDF_Options(pdecoder, optmode);
   
    k = 0;
	for (k=0;k<1000;k++){
      if (files[k]== NULL)
        break; 
     // ==== read image into pbits:
      rowcount = maxR;
      colcount = maxC;
      ResLoadBMP = LoadBMP ((char*)files[k], pbits ,rowcount ,colcount);
      if(ResLoadBMP != 0) {
         printf("ResLoadBMP == %d \n", ResLoadBMP);
		 continue;
      }
      printf("\n");
	  for (iBWF= 0; iBWF<=1; iBWF++){
        printf("\n   %s,   ",files[k]);
		printf("BW Filter = %d,    ", iBWF==0 ? 0 :-1);
        DecodePDF_Bits(pdec_with_options[iBWF], rowcount, colcount, pbits);
        // ==== get decode results:
        pimageinfo = GetPDF_ImageInfo(pdec_with_options[iBWF]);
        printf("Error Code = %d\n",pimageinfo->RejectionReason);
        DecodedSymbolNo = pimageinfo->SymbolCount;
        if (DecodedSymbolNo>0){
          for (i=0; i<DecodedSymbolNo; i++){
            pinfo = GetPDF_Info(pdec_with_options[iBWF],i);
            // ==== display pinfo ...
            if (pinfo->pchlen > 0)
              printf("Decode Result:\n   %s\n", pinfo->pch);
            else
              printf("Length of Decode Result = 0\n");
          }
		  break;
        //}else{
        //  printf("No Code PDF417 Found\n");
        }
	  }
    }
    Delete_PDF_Options(pdec_with_options[0]);
    Delete_PDF_Options(pdec_with_options[1]);
    Disconnect_PDF_Decoder (pdecoder);
    ::FreeLibrary(DLLInstance);
  }
DoExit:
  printf("Print 'Enter' to exit >");
  scanf("%c",&ch);
  return 0;
}
